#include "DeerStudio/StudioAPI/Engine.h"
#include "DeerStudio/EditorEngine.h"
#include "angelscript.h"
#include "scriptstdstring.h"

#include "Deer/Path.h"
#include <string>

namespace Deer {
	namespace EditorEngine {
		std::string getParentPath(std::string& path) {
			return Path(path).parent_path().string();
		}

		std::string getParentPathName(std::string& path) {
			return Path(path).parent_path().stem().string();
		}

		CScriptArray* dividePath(std::string& path_s) {
			asITypeInfo* arrType =
			    EditorEngine::scriptEngine->GetTypeInfoByDecl("array<string>");

			CScriptArray* array = CScriptArray::Create(arrType);

			Path path_p(path_s);
			for (const auto& part : path_p) {
				std::string s = part.string();

				array->Resize(array->GetSize() + 1);
				array->SetValue(array->GetSize() - 1, &s);
			}

			return array;
		}
	} // namespace EditorEngine
} // namespace Deer